/*
* Licensed to the Apache Software Foundation (ASF) under one or more
* contributor license agreements.  See the NOTICE file distributed with
* this work for additional information regarding copyright ownership.
* The ASF licenses this file to You under the Apache License, Version 2.0
* (the "License"); you may not use this file except in compliance with
* the License.  You may obtain a copy of the License at
*
*     http://www.apache.org/licenses/LICENSE-2.0
*
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
*/

    package com.ywt.gapi.checkup_booking;

import org.apache.dubbo.common.stream.StreamObserver;
import com.google.protobuf.Message;

import java.util.HashMap;
import java.util.Map;
import java.util.function.BiConsumer;
import java.util.concurrent.CompletableFuture;

public interface CheckupBookingService extends org.apache.dubbo.rpc.model.DubboStub {

    String JAVA_SERVICE_NAME = "com.ywt.gapi.checkup_booking.CheckupBookingService";
    String SERVICE_NAME = "com.ywt.gapi.checkup_booking.CheckupBookingService";

        /**
         * <pre>
         *  套餐等级 id
         * </pre>
         */
    com.ywt.gapi.checkup_booking.GetPackageLevelListResponse getPackageLevelList(com.ywt.gapi.checkup_booking.GetPackageLevelListRequest request);

    default CompletableFuture<com.ywt.gapi.checkup_booking.GetPackageLevelListResponse> getPackageLevelListAsync(com.ywt.gapi.checkup_booking.GetPackageLevelListRequest request){
        return CompletableFuture.completedFuture(getPackageLevelList(request));
    }

    /**
    * This server stream type unary method is <b>only</b> used for generated stub to support async unary method.
    * It will not be called if you are NOT using Dubbo3 generated triple stub and <b>DO NOT</b> implement this method.
    */
    default void getPackageLevelList(com.ywt.gapi.checkup_booking.GetPackageLevelListRequest request, StreamObserver<com.ywt.gapi.checkup_booking.GetPackageLevelListResponse> responseObserver){
        getPackageLevelListAsync(request).whenComplete((r, t) -> {
            if (t != null) {
                responseObserver.onError(t);
            } else {
                responseObserver.onNext(r);
                responseObserver.onCompleted();
            }
        });
    }

        /**
         * <pre>
         *  套餐等级名称
         * </pre>
         */
    com.ywt.gapi.checkup_booking.GetPackageListResponse getPackageList(com.ywt.gapi.checkup_booking.GetPackageListRequest request);

    default CompletableFuture<com.ywt.gapi.checkup_booking.GetPackageListResponse> getPackageListAsync(com.ywt.gapi.checkup_booking.GetPackageListRequest request){
        return CompletableFuture.completedFuture(getPackageList(request));
    }

    /**
    * This server stream type unary method is <b>only</b> used for generated stub to support async unary method.
    * It will not be called if you are NOT using Dubbo3 generated triple stub and <b>DO NOT</b> implement this method.
    */
    default void getPackageList(com.ywt.gapi.checkup_booking.GetPackageListRequest request, StreamObserver<com.ywt.gapi.checkup_booking.GetPackageListResponse> responseObserver){
        getPackageListAsync(request).whenComplete((r, t) -> {
            if (t != null) {
                responseObserver.onError(t);
            } else {
                responseObserver.onNext(r);
                responseObserver.onCompleted();
            }
        });
    }

        /**
         * <pre>
         *  科室代码
         * </pre>
         */
    com.ywt.gapi.checkup_booking.GetPackageItemListResponse getPackageItemList(com.ywt.gapi.checkup_booking.GetPackageItemListRequest request);

    default CompletableFuture<com.ywt.gapi.checkup_booking.GetPackageItemListResponse> getPackageItemListAsync(com.ywt.gapi.checkup_booking.GetPackageItemListRequest request){
        return CompletableFuture.completedFuture(getPackageItemList(request));
    }

    /**
    * This server stream type unary method is <b>only</b> used for generated stub to support async unary method.
    * It will not be called if you are NOT using Dubbo3 generated triple stub and <b>DO NOT</b> implement this method.
    */
    default void getPackageItemList(com.ywt.gapi.checkup_booking.GetPackageItemListRequest request, StreamObserver<com.ywt.gapi.checkup_booking.GetPackageItemListResponse> responseObserver){
        getPackageItemListAsync(request).whenComplete((r, t) -> {
            if (t != null) {
                responseObserver.onError(t);
            } else {
                responseObserver.onNext(r);
                responseObserver.onCompleted();
            }
        });
    }

        /**
         * <pre>
         *  HIS套餐ID
         * </pre>
         */
    com.ywt.gapi.checkup_booking.GetAllItemListResponse getAllItemList(com.ywt.gapi.checkup_booking.GetAllItemListRequest request);

    default CompletableFuture<com.ywt.gapi.checkup_booking.GetAllItemListResponse> getAllItemListAsync(com.ywt.gapi.checkup_booking.GetAllItemListRequest request){
        return CompletableFuture.completedFuture(getAllItemList(request));
    }

    /**
    * This server stream type unary method is <b>only</b> used for generated stub to support async unary method.
    * It will not be called if you are NOT using Dubbo3 generated triple stub and <b>DO NOT</b> implement this method.
    */
    default void getAllItemList(com.ywt.gapi.checkup_booking.GetAllItemListRequest request, StreamObserver<com.ywt.gapi.checkup_booking.GetAllItemListResponse> responseObserver){
        getAllItemListAsync(request).whenComplete((r, t) -> {
            if (t != null) {
                responseObserver.onError(t);
            } else {
                responseObserver.onNext(r);
                responseObserver.onCompleted();
            }
        });
    }

        /**
         * <pre>
         *  类型描述
         * </pre>
         */
    com.ywt.gapi.checkup_booking.GetRegInfoListResponse getRegInfoList(com.ywt.gapi.checkup_booking.GetRegInfoListRequest request);

    default CompletableFuture<com.ywt.gapi.checkup_booking.GetRegInfoListResponse> getRegInfoListAsync(com.ywt.gapi.checkup_booking.GetRegInfoListRequest request){
        return CompletableFuture.completedFuture(getRegInfoList(request));
    }

    /**
    * This server stream type unary method is <b>only</b> used for generated stub to support async unary method.
    * It will not be called if you are NOT using Dubbo3 generated triple stub and <b>DO NOT</b> implement this method.
    */
    default void getRegInfoList(com.ywt.gapi.checkup_booking.GetRegInfoListRequest request, StreamObserver<com.ywt.gapi.checkup_booking.GetRegInfoListResponse> responseObserver){
        getRegInfoListAsync(request).whenComplete((r, t) -> {
            if (t != null) {
                responseObserver.onError(t);
            } else {
                responseObserver.onNext(r);
                responseObserver.onCompleted();
            }
        });
    }

        /**
         * <pre>
         *  类型ID
         * </pre>
         */
    com.ywt.gapi.checkup_booking.GetDateRegInfoResponse getDateRegInfo(com.ywt.gapi.checkup_booking.GetDateRegInfoRequest request);

    default CompletableFuture<com.ywt.gapi.checkup_booking.GetDateRegInfoResponse> getDateRegInfoAsync(com.ywt.gapi.checkup_booking.GetDateRegInfoRequest request){
        return CompletableFuture.completedFuture(getDateRegInfo(request));
    }

    /**
    * This server stream type unary method is <b>only</b> used for generated stub to support async unary method.
    * It will not be called if you are NOT using Dubbo3 generated triple stub and <b>DO NOT</b> implement this method.
    */
    default void getDateRegInfo(com.ywt.gapi.checkup_booking.GetDateRegInfoRequest request, StreamObserver<com.ywt.gapi.checkup_booking.GetDateRegInfoResponse> responseObserver){
        getDateRegInfoAsync(request).whenComplete((r, t) -> {
            if (t != null) {
                responseObserver.onError(t);
            } else {
                responseObserver.onNext(r);
                responseObserver.onCompleted();
            }
        });
    }

        /**
         * <pre>
         *  团体标志：个人、团体
         * </pre>
         */
    com.ywt.gapi.checkup_booking.SaveRegRecordResponse saveRegRecord(com.ywt.gapi.checkup_booking.SaveRegRecordRequest request);

    default CompletableFuture<com.ywt.gapi.checkup_booking.SaveRegRecordResponse> saveRegRecordAsync(com.ywt.gapi.checkup_booking.SaveRegRecordRequest request){
        return CompletableFuture.completedFuture(saveRegRecord(request));
    }

    /**
    * This server stream type unary method is <b>only</b> used for generated stub to support async unary method.
    * It will not be called if you are NOT using Dubbo3 generated triple stub and <b>DO NOT</b> implement this method.
    */
    default void saveRegRecord(com.ywt.gapi.checkup_booking.SaveRegRecordRequest request, StreamObserver<com.ywt.gapi.checkup_booking.SaveRegRecordResponse> responseObserver){
        saveRegRecordAsync(request).whenComplete((r, t) -> {
            if (t != null) {
                responseObserver.onError(t);
            } else {
                responseObserver.onNext(r);
                responseObserver.onCompleted();
            }
        });
    }

        /**
         * <pre>
         *  性别描述
         * </pre>
         */
    com.ywt.gapi.checkup_booking.CancelRegResponse cancelReg(com.ywt.gapi.checkup_booking.CancelRegRequest request);

    default CompletableFuture<com.ywt.gapi.checkup_booking.CancelRegResponse> cancelRegAsync(com.ywt.gapi.checkup_booking.CancelRegRequest request){
        return CompletableFuture.completedFuture(cancelReg(request));
    }

    /**
    * This server stream type unary method is <b>only</b> used for generated stub to support async unary method.
    * It will not be called if you are NOT using Dubbo3 generated triple stub and <b>DO NOT</b> implement this method.
    */
    default void cancelReg(com.ywt.gapi.checkup_booking.CancelRegRequest request, StreamObserver<com.ywt.gapi.checkup_booking.CancelRegResponse> responseObserver){
        cancelRegAsync(request).whenComplete((r, t) -> {
            if (t != null) {
                responseObserver.onError(t);
            } else {
                responseObserver.onNext(r);
                responseObserver.onCompleted();
            }
        });
    }

        /**
         * <pre>
         *  备注
         * </pre>
         */
    com.ywt.gapi.checkup_booking.GetRegRecordListResponse getRegRecordList(com.ywt.gapi.checkup_booking.GetRegRecordListRequest request);

    default CompletableFuture<com.ywt.gapi.checkup_booking.GetRegRecordListResponse> getRegRecordListAsync(com.ywt.gapi.checkup_booking.GetRegRecordListRequest request){
        return CompletableFuture.completedFuture(getRegRecordList(request));
    }

    /**
    * This server stream type unary method is <b>only</b> used for generated stub to support async unary method.
    * It will not be called if you are NOT using Dubbo3 generated triple stub and <b>DO NOT</b> implement this method.
    */
    default void getRegRecordList(com.ywt.gapi.checkup_booking.GetRegRecordListRequest request, StreamObserver<com.ywt.gapi.checkup_booking.GetRegRecordListResponse> responseObserver){
        getRegRecordListAsync(request).whenComplete((r, t) -> {
            if (t != null) {
                responseObserver.onError(t);
            } else {
                responseObserver.onNext(r);
                responseObserver.onCompleted();
            }
        });
    }

        /**
         * <pre>
         *  科室ID
         * </pre>
         */
    com.ywt.gapi.checkup_booking.GetUncheckedRecordResponse getUncheckedRecord(com.ywt.gapi.checkup_booking.GetUncheckedRecordRequest request);

    default CompletableFuture<com.ywt.gapi.checkup_booking.GetUncheckedRecordResponse> getUncheckedRecordAsync(com.ywt.gapi.checkup_booking.GetUncheckedRecordRequest request){
        return CompletableFuture.completedFuture(getUncheckedRecord(request));
    }

    /**
    * This server stream type unary method is <b>only</b> used for generated stub to support async unary method.
    * It will not be called if you are NOT using Dubbo3 generated triple stub and <b>DO NOT</b> implement this method.
    */
    default void getUncheckedRecord(com.ywt.gapi.checkup_booking.GetUncheckedRecordRequest request, StreamObserver<com.ywt.gapi.checkup_booking.GetUncheckedRecordResponse> responseObserver){
        getUncheckedRecordAsync(request).whenComplete((r, t) -> {
            if (t != null) {
                responseObserver.onError(t);
            } else {
                responseObserver.onNext(r);
                responseObserver.onCompleted();
            }
        });
    }






}
